Attribute VB_Name = "Module1"
Option Explicit

' alle bentigten API's
Private Declare Function GetWindow Lib "user32" _
    (ByVal hWnd As Long, ByVal wCmd As Long) As Long
       
Private Declare Function GetWindowLong Lib "user32" _
  Alias "GetWindowLongA" (ByVal hWnd As Long, _
  ByVal wIndx As Long) As Long
       
Private Declare Function GetWindowTextLength Lib "user32" _
  Alias "GetWindowTextLengthA" (ByVal hWnd As Long) As Long
       
Private Declare Function GetWindowText Lib "user32" _
  Alias "GetWindowTextA" (ByVal hWnd As Long, _
  ByVal lpString As String, ByVal cch As Long) As Long
       
Private Declare Function GetWindowThreadProcessId Lib _
  "user32" (ByVal hWnd As Long, lpdwProcessId As Long) _
  As Long

Const GW_HWNDFIRST = 0
Const GW_HWNDLAST = 1
Const GW_HWNDNEXT = 2
Const GW_HWNDPREV = 3
Const GW_OWNER = 4
Const GW_CHILD = 5
Const GW_MAX = 5

Const GWL_STYLE = (-16)

Const WS_VISIBLE = &H10000000
Const WS_BORDER = &H800000
Public Function GetWindowList(oLSV As ListView, Optional bVisible As Boolean = True)
 
  ' oLSV     - Ein beliebiges ListView, das die
  '            Informationen aufnehmen soll
  ' bVisible - Wenn True werden nur sichtbare Windows
  '             angezeigt, ansonsten alle
  Dim a As Integer
  Dim j As Integer
  Dim hWnd      As Long
  Dim sTitle    As String
  Dim lStyle    As Long
  Dim oListItem As ListItem
  Dim ProzCount As String
  
 
  ' ListView-Spalten festlegen
  With oLSV.ColumnHeaders
    .Clear
    .Add , "hWnd", "hWnd"
    .Add , "Title", "Titel"
  End With
  
  ' Inhalt lschen und umschalten auf "Detail"-Ansicht
  oLSV.ListItems.Clear
  oLSV.View = lvwReport
 
  ' Erstes WindowHandle holen
  hWnd = GetWindow(oLSV.Parent.hWnd, GW_HWNDFIRST)
  
   j = 0

  Do
    ' Handle auswerten und im ListView eintragen
    lStyle = GetWindowLong(hWnd, GWL_STYLE)
    lStyle = lStyle And (WS_VISIBLE Or WS_BORDER)
    sTitle = GetWindowTitle(hWnd)

    If (lStyle = (WS_VISIBLE Or WS_BORDER)) = bVisible Then
      ' in das ListView eintragen
      Set oListItem = oLSV.ListItems.Add(, , hWnd)
       
      With oListItem
        .SubItems(1) = sTitle
      End With
    End If
     
       If (lStyle = (WS_VISIBLE Or WS_BORDER)) = True Then
       
      ' Titelzeile ermitteln und prfen, ob "Solid Edge" darin enthalten ist
          sTitle = GetWindowTitle(hWnd)
            If InStr(1, sTitle, "Solid Edge", vbTextCompare) > 0 Then
              j = j + 1
            End If
       End If
    ' Nchtses Handle
    hWnd = GetWindow(hWnd, GW_HWNDNEXT)
  
  Loop Until hWnd = 0

      If j > 1 Then
               ProzCount = Str$(j)
               
               a = MsgBox("  Solid Edge ist " + ProzCount + "mal gestartet!", 49, "  Achtung: mgliche Fehlerquelle!")
                  
                  Select Case a
                     Case 1: Exit Function    'die Taste  "OK"  wurde gedrckt
                     Case 2: End                      '   "Abbrechen" wurde gedrckt
                  End Select
               Else
               Exit Function
      End If
      
End Function

Private Function GetWindowTitle(ByVal hWnd As Long) _
  As String
 
  ' Ermittelt den Namen eines Windows anhand des
  ' Window Handle
 
  Dim lResult As Long
  Dim sTemp As String
 
  lResult = GetWindowTextLength(hWnd) + 1
  sTemp = Space(lResult)
  lResult = GetWindowText(hWnd, sTemp, lResult)
  GetWindowTitle = Left(sTemp, Len(sTemp) - 1)
End Function



